//#include <time.h>
#include <unistd.h>

#include <SDL.h>
//#include <SDL_mixer.h>
//#include <SDL_image.h>
#include <SDL_ttf.h>
#include <switch.h>

#define JOY_PLUS  10

template<typename T>
constexpr T WIDTHSCREEN{800};

template<typename T>
constexpr T HEIGHTSCREEN{600};

int main(int argc, char* argv[])
{
		romfsInit();
    chdir("romfs:/");
    
    if (SDL_Init(SDL_INIT_VIDEO) < 0)
    {
        SDL_LogError(SDL_LOG_CATEGORY_ERROR, "[DEBUG] > %s", SDL_GetError());
        return EXIT_FAILURE;
    }

    if (TTF_Init() < 0)
    {
        SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "[DEBUG] > %s", SDL_GetError());
        return EXIT_FAILURE;    
    }
   
    int exit_requested = 0;

    
    SDL_Window* pWindow = SDL_CreateWindow("SDL_CreateTexture", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, 800, 600, SDL_WINDOW_RESIZABLE);
    SDL_Renderer* pRenderer = SDL_CreateRenderer(pWindow, -1, 0);
    TTF_Font* font = TTF_OpenFont("data/font.ttf", 38);
    SDL_Surface* text = TTF_RenderText_Blended(font, "MrDude Woz ERE", SDL_Color{0, 0, 255, 255});
    SDL_Texture* texture = SDL_CreateTextureFromSurface(pRenderer, text);
    SDL_Rect position;
    SDL_QueryTexture(texture, NULL, NULL, &position.w, &position.h);
    position.x = WIDTHSCREEN<int> / 2 - position.w / 2;
    position.y = HEIGHTSCREEN<int> / 2 - position.h / 2;

    SDL_Event events;

    TTF_CloseFont(font); SDL_FreeSurface(text);

    SDL_Point center = { position.w / 2, position.h / 2 };
    double angle = 0;
    SDL_RendererFlip flip = static_cast<SDL_RendererFlip>(SDL_FLIP_NONE);

    while (!exit_requested && appletMainLoop())
    {
        while(SDL_PollEvent(&events))
        {
            if(events.type == SDL_QUIT)
                exit_requested = 1;

            if (events.type == SDL_JOYBUTTONDOWN) {
                if (events.jbutton.button == JOY_PLUS)
                exit_requested = 1;}
        }

        if (angle > 360)
            angle = 0;
        if (angle < 0)
            angle = 360;

        angle++;

        SDL_SetRenderDrawColor(pRenderer, 0, 0, 0, 255);
        SDL_RenderClear(pRenderer);

        SDL_SetRenderDrawColor(pRenderer, 0, 255, 0, 255);
        SDL_RenderCopyEx(pRenderer, texture, nullptr, &position, angle, &center, flip);
        

        SDL_RenderPresent(pRenderer);
        SDL_Delay(5);

    }

    SDL_DestroyWindow(pWindow); SDL_DestroyRenderer(pRenderer); SDL_DestroyTexture(texture); TTF_CloseFont(font); SDL_FreeSurface(text);
    SDL_Quit();
    romfsExit();
    return EXIT_SUCCESS;
}